import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;

import javax.sql.DataSource;

import org.springframework.context.ApplicationContext;
import org.springframework.context.support.ClassPathXmlApplicationContext;
import org.springframework.dao.DataAccessException;
import org.springframework.jdbc.core.JdbcTemplate;
import org.springframework.jdbc.core.PreparedStatementSetter;
import org.springframework.jdbc.core.ResultSetExtractor;

class Main {
  public static void main(String args[]) throws Exception {
    ApplicationContext ac = new ClassPathXmlApplicationContext("context.xml", Main.class);
    DataSource dataSource = (DataSource) ac.getBean("dataSource");
    // DataSource mysqlDataSource = (DataSource) ac.getBean("mysqlDataSource");

    JdbcTemplate jdbcTemplate = new JdbcTemplate(dataSource);

    String firstCustomersName = (String) jdbcTemplate.query(
        "select first_name from t_customer where id=?", new PreparedStatementSetter() {
          public void setValues(PreparedStatement preparedStatement) throws SQLException {
            preparedStatement.setLong(1, 1L);
          }
        }, new FirstColumnStringExtractor());
    System.out.println(firstCustomersName);
  }
}

class FirstColumnStringExtractor implements ResultSetExtractor {
  public Object extractData(ResultSet resultSet) throws SQLException, DataAccessException {
    if (resultSet.next()) {
      return resultSet.getString(1);
    }
    return null;
  }
}
